 //+------------------------------------------------------------------+
//|                                                     333CG_EA.mq4 |
//|                                                     Raymond Omeh |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "153600"
#property link      ""
#property version   "1.00"
#property strict

#include <Arrays\ArrayObj.mqh>
#include <Arrays\ArrayInt.mqh>
#include <Arrays\ArrayDouble.mqh>
#include <Arrays\ArrayString.mqh>
#define PASSWORD "0000"
#define NOTIF "This EA is best for a one hour chart or higher"
#define Prefix "333CG"
#define linePrefix "PNV"

enum eMACDBuffer {
   MODE_MAIN_ = 0,
   MODE_SIGNAL_ = 1
};

enum exit{

   A,       //Old Exit Feature
   B,       //New Exit Feature
};

sinput string Trade = "=========Trade Settings========="; //=======================
input int BarsInView = 144;
string AllowedTrades = "1,2,3,4,5,6,7,8,9,10,11,12,13,14";
input double LotSize = 0.5;      //X Lots
input bool MultiLot;             //Multi-Lot
input double TakeProfit = 0;     //TakeProfit (pips)
input double TakeProfitD = 0;    //TakeProfit in $
input double StopLoss = 200;     //StopLoss (pips)
input double StopLossD = 0;      //StopLoss in $
input double MaxSpread = 3;      //Spread Protection (pips)
input bool FridayExit = false;   //Exit On Friday
input exit exit_feature;         //Exit Feature
input double DailyProfit = 0;    //DailyProfit $ (0=disabled)
input double DailyLoss = 200;    //DailyLoss $ (0=disabled)
string FridayExitTime = "23:58";
input bool AutoLot = false;      //Money Management
input double Risk = 5;           //Risk (percent)
input bool ReverseTrades = false;
input bool TradeInDirectionOfMA = true;
input int MATrades = 0;          //Use MA Trades for Profits
input int  CloseAfterX = 0;      //CloseAfterXCandles
input double CloseOnPositiveXDollar = 0;
input int MagicNumber = 012;
string EaName = "P&V EA";
input string Password = "0000";
sinput string Indicators = "=========Indicators========"; //=====================
input int MACDFastEMA = 4;
input int MACDSlowEMA = 5;
input int MACDSMA = 1;
input eMACDBuffer MACDBuffer = MODE_MAIN_;
input ENUM_APPLIED_PRICE MACDAppliedPrice = PRICE_CLOSE;

input int RSIPeriod = 2;
input ENUM_APPLIED_PRICE RSIPrice = PRICE_CLOSE;
input int RSIUpperLevel = 90;
input int RSILowerLevel = 10;

input int MAPeriod   = 42;
input int MAShift    = 0;
input ENUM_MA_METHOD MAMethod = MODE_SMMA;
input ENUM_APPLIED_PRICE MAAppliedPrice = PRICE_CLOSE;
sinput string Text = "=========Text========"; //=====================
input color BuyColor = clrWhite;
input color SellColor = clrTomato;
input bool UseRuleNumAboveTrades = true;

double SL, TP, LOT;
double pips;
double myLastAccountBalance;
double myAccountBalance;
double myAccountProfit;
double myAccountEquity;

bool ONBUY = false, ONSELL = false;

int OpenPositions = 0;
double CurrentCandle, PriceOpenTrade;
bool NewCandle = true, NewDay = true;
double InitialCandleOpenTrade = 0, InitialCandleCloseTrade = 999999999;
bool NotifSent = false, EmailSent = false;
bool broken_even = false, buyLock = false, sellLock = false;
double LastTrade, TodayProfit;
int EHandle,BBHandle;
long MABuyTradeTicket, MASellTradeTicket;
int OpenBuyPositions = 0, OpenSellPositions;

double BBUBLACKopen, BBMBLACKopen, BBLBLACKopen, BBUBLUEopen, BBMBLUEopen, BBLBLUEopen, BBUAQUAopen, BBMAQUAopen, BBLAQUAopen, EUYopen, ELRopen, MAGopen;
bool BuyFree, SellFree;
int CandlesOnTradeElapsed = 0;
int CurrentSignal = 0;
datetime LaunchCandle;
int MA0TradeCount = 0;
string allowedTrades[];
int total_bars;

#define CLOSE_REASON_MACD 0
#define CLOSE_REASON_TP 1
#define CLOSE_REASON_SL 2
#define CLOSE_REASON_DAILY_PROFIT 3
#define CLOSE_REASON_DAILY_LOSS 4
#define CLOSE_REASON_OPPOSITE_TRADE 5
#define CLOSE_REASON_X_CANDLES 6
#define CLOSE_REASON_MA_TURN 7

int OnInit() {
    StringSplit(AllowedTrades,',',allowedTrades);
    ChartSetInteger(0, CHART_SHOW_GRID, false);
    ChartSetInteger(0, CHART_MODE, 1);
    ChartSetInteger(0, CHART_SHOW_PERIOD_SEP, 1);
     
    SL = StopLoss;
    TP = TakeProfit;
    LOT = LotSize;

    if (_Digits % 2 == 1)
        pips = _Point * 10;
    else
        pips = _Point;
    
    if(Password != (string)PASSWORD){
      Comment("Incorrect Password");
      Print("Incorrect Password");
      ExpertRemove();
      return INIT_FAILED;
    }
    
    TesterHideIndicators(false);
    DrawText(NOTIF);
    LaunchCandle = iTime(_Symbol,_Period,0);
    Print(EaName, " Started");
    total_bars = Bars;
    return (0);
}

void DrawText(string text) {
   string name = Prefix + "-notif";
   ObjectDelete(0, name);
   if (ObjectCreate(0, name, OBJ_LABEL, 0, 0, 0)) {
      ObjectSetString(0, name, OBJPROP_TEXT, text);
      ObjectSetInteger(0, name, OBJPROP_WIDTH, 9);
      ObjectSetInteger(0, name, OBJPROP_CORNER, CORNER_LEFT_LOWER);
      ObjectSetInteger(0, name, OBJPROP_XDISTANCE, 5);
      ObjectSetInteger(0, name, OBJPROP_YDISTANCE, 20);
      ObjectSetInteger(0, name, OBJPROP_SELECTABLE, false);
      ObjectSetInteger(0, name, OBJPROP_HIDDEN, true);
      ObjectSetInteger(0, name, OBJPROP_COLOR, clrGreen);
      ObjectSetString(0,name, OBJPROP_TEXT, text);
   } else {
      Print("Error - ", GetLastError());
   }
}

void OnTick() {
    if(FridayExit && !CheckTime())
      return;
          
    double Spread = (int)SymbolInfoInteger(_Symbol, SYMBOL_SPREAD) / 10;
    if (Spread > MaxSpread && MaxSpread != 0) {
        Print("Spread ", Spread, " is greater than MaxSpread ", MaxSpread, ". Trading Paused");
        return;
    }
    
    myAccountBalance = AccountInfoDouble(ACCOUNT_BALANCE);
    myAccountProfit = AccountInfoDouble(ACCOUNT_PROFIT);
    myAccountEquity = AccountInfoDouble(ACCOUNT_EQUITY);
    
    //MakeComment();
    CheckOrdersProfit();
    LOT = LotSize;
    
    //+--Candle Stick Get Prices                                          
    MqlRates PriceInfo[];
    ArraySetAsSeries(PriceInfo, true);
    int PriceData = CopyRates(_Symbol, _Period, 0, 12, PriceInfo);
    OpenPositions = CountOpenPositions();
    
    if (CurrentCandle != iOpen(_Symbol,_Period,0)) {
        CurrentCandle = iOpen(_Symbol,_Period,0);
        NewCandle = true;
        //SetCandleOpenParameters();
        if(OpenPositions > 0)
           CandlesOnTradeElapsed++;
    } else {
        NewCandle = false;
        //return;
    }
    
    int first = 0, follow = 1, extend = 2;
    
    ENUM_ORDER_TYPE ordertypeclosed = CheckOrdersToClose();
    
    TodayProfit = GetTodayProfit();
    if (TodayProfit >= DailyProfit && DailyProfit != 0) {
        CloseBuyOrders(CLOSE_REASON_DAILY_PROFIT);
        CloseSellOrders(CLOSE_REASON_DAILY_PROFIT);
        Comment("Daily Profit Reached. Trading Suspended");
        //SendNotification("Daily Profit Reached. Trading Suspended");
        return;
    }
    
    if (TodayProfit <= (fabs(DailyLoss)*-1) && DailyLoss != 0) {
        CloseBuyOrders(CLOSE_REASON_DAILY_LOSS);
        CloseSellOrders(CLOSE_REASON_DAILY_LOSS);
        Comment("Daily Loss Reached. Trading Suspended");
        //SendNotification("Daily Loss Reached. Trading Suspended");
        return;
    }
    
    
    if(false && LaunchCandle == iTime(_Symbol,_Period,0))
      return;
    
    datetime RSIValley1Found;
    datetime RSIValley2Found;
    datetime RSIValley3Found;
    datetime RSIPeak1Found;
    datetime RSIPeak2Found;
    datetime RSIPeak3Found;
    datetime MACDValley1Found;
    datetime MACDValley2Found;
    datetime MACDValley3Found;
    datetime MACDPeak1Found;
    datetime MACDPeak2Found;
    datetime MACDPeak3Found;
    
    datetime MACDValleyAbove0Found;
    datetime MACDPeakBelow0Found;
    
    double RSIValley1 = GetRSIValley(Time(0), RSIValley1Found);
    double RSIValley2 = GetRSIValley(RSIValley1Found, RSIValley2Found);
    double RSIValley3 = GetRSIValley(RSIValley2Found, RSIValley3Found);
    double RSIPeak1 = GetRSIPeak(Time(0), RSIPeak1Found);
    double RSIPeak2 = GetRSIPeak(RSIPeak1Found, RSIPeak2Found);
    double RSIPeak3 = GetRSIPeak(RSIPeak2Found, RSIPeak3Found);
    double MACDValley1 = GetMACDValley(Time(0), MACDValley1Found);
    double MACDValley2 = GetMACDValley(MACDValley1Found, MACDValley2Found);
    double MACDValley3 = GetMACDValley(MACDValley2Found, MACDValley3Found);
    double MACDPeak1 = GetMACDPeak(Time(0), MACDPeak1Found);
    double MACDPeak2 = GetMACDPeak(MACDPeak1Found, MACDPeak2Found);
    double MACDPeak3 = GetMACDPeak(MACDPeak2Found, MACDPeak3Found);
    
    double MACDValleyAbove0 = GetMACDValleyAbove0(Time(0), MACDValleyAbove0Found);
    double MACDPeakBelow0 = GetMACDPeakBelow0(Time(0), MACDPeakBelow0Found);
    
    //-Trade conditions
    bool Sell      = RSI(first) >= RSIUpperLevel && RSI(first) < RSI(follow) && RSI(follow) > RSI(extend);
    bool Sell2     = MACDLEVEL(first) >= RSIUpperLevel;
    bool Sell3     = MACDPeak1Found == Time(1) && MACDLEVEL(1) >= RSIUpperLevel && (MACDValley1 < MACDValley2 || MACDValley1 < MACDValley3) && (MACDValley1 > MACDValley2 || MACDValley1 > MACDValley3); 
    bool Sell4     = RSIPeak1Found == Time(1) && RSI(1) >= RSIUpperLevel && (RSIPeak1 > RSIPeak2 || RSIPeak1 > RSIPeak3) && (RSIPeak1 < RSIPeak2 || RSIPeak1 < RSIPeak3);
    bool Sell5     = RSIPeak1Found == Time(1) && (RSIPeak1 > RSIPeak2 || RSIPeak1 > RSIPeak3) && (RSIPeak1 < RSIPeak2 || RSIPeak1 < RSIPeak3);
    bool Sell6     = MACDPeakBelow0Found == Time(1);
    bool Sell7     = MACDPeak1Found == Time(1) && MACD(1) > 0;
    
    bool Sell8      = RSIValley1Found == Time(1) && (RSIValley1 > RSIValley2 || RSIValley1 > RSIValley3) && (RSIValley1 < RSIValley2 || RSIValley1 < RSIValley3);
    bool Sell9      = RSIValley1Found == Time(1) && (RSIValley1 < RSIValley2 || RSIValley1 > RSIValley3) && (RSIValley1 < RSIValley2 || RSIValley1 < RSIValley3);
    
    bool Buy       = RSI(first) <= RSILowerLevel && RSI(first) > RSI(follow) && RSI(follow) < RSI(extend);
    bool Buy2      = MACDLEVEL(first) <= RSILowerLevel;
    bool Buy4      = MACDValley1Found == Time(1) && MACDLEVEL(1) <= RSILowerLevel && (MACDValley1 > MACDValley2 || MACDValley1 > MACDValley3) && (MACDValley1 < MACDValley2 || MACDValley1 < MACDValley3); 
    bool Buy6      = MACDValley1Found == Time(1) && MACD(1) < 0;
    bool Buy7      = MACDValleyAbove0Found == Time(1);  
    
    
    if(CandlesOnTradeElapsed >= CloseAfterX && CloseAfterX > 0){
         Print("Closing Trade After ", CloseAfterX, " candles");
         CloseSellOrders(CLOSE_REASON_X_CANDLES);
         CloseBuyOrders(CLOSE_REASON_X_CANDLES);
         SellFree = false;
         BuyFree = false;
    }
    
    if(MA(1) > MA(2) && (Open[0] != InitialCandleOpenTrade)){
      if(MATrades > 0 && OpenBuyPositions > 0 && MA0TradeCount < MATrades)
         PlaceBuyOrder(LOT, TP, SL, 0, "-");
    }
    if(MA(1) < MA(2) && (Open[0] != InitialCandleOpenTrade)){
      if(MATrades > 0 && OpenSellPositions > 0 && MA0TradeCount < MATrades)
         PlaceSellOrder(LOT, TP, SL, 0, "-");
    }
    
   if(exit_feature==0){
    /*if(MADIR() > 0 && ONSELL){
      CloseSellOrders(CLOSE_REASON_MA_TURN);
    }
    
    if(MADIR() < 0 && ONBUY){
      CloseBuyOrders(CLOSE_REASON_MA_TURN);
    }*/
  }
    else{
    
      if(isNewCandle()){
      
        if(MA(0) > MA(1))CloseSellOrders(CLOSE_REASON_MA_TURN);
        if(MA(0) < MA(1))CloseBuyOrders(CLOSE_REASON_MA_TURN);
      }
    }
          
    if ((Buy || Buy2 || Buy4 || Buy6 || Buy7) && (Open[0] != InitialCandleOpenTrade) && ((!ReverseTrades && OpenBuyPositions == 0 && (!TradeInDirectionOfMA || (TradeInDirectionOfMA && MADIR() > 0))) || (ReverseTrades && OpenSellPositions == 0 && (!TradeInDirectionOfMA || (TradeInDirectionOfMA && MADIR() < 0))))) {
        CurrentSignal = Buy ? 1 : Buy2 ? 2 : Buy4 ? 6 : Buy6 ? 12 : 14;
        if(!TradeAllowed(IntegerToString(CurrentSignal)))return;
        if((!ReverseTrades && ordertypeclosed == ORDER_TYPE_BUY) || (ReverseTrades && ordertypeclosed == ORDER_TYPE_SELL))return;
         
        SellFree = false;   
        /*if(!ReverseTrades)     
          CloseSellOrders(CLOSE_REASON_OPPOSITE_TRADE);
        else
          CloseBuyOrders(CLOSE_REASON_OPPOSITE_TRADE);*/
        
        LOT = (AutoLot || LotSize == 0) ? GetFlexibleLot(SL) : LotSize;
        if(MultiLot)LOT *= 3;
        
        if(MA(1) > MA(2))
        PlaceBuyOrder(LOT, TP, SL, CurrentSignal, "");
    }

    if ((Sell || Sell2 || Sell3 || Sell4 || Sell5 || Sell6 || Sell7 || Sell8 || Sell9) && (Open[0] != InitialCandleOpenTrade) && ((!ReverseTrades && OpenSellPositions == 0 && (!TradeInDirectionOfMA || (TradeInDirectionOfMA && MADIR() < 0))) || (ReverseTrades && OpenBuyPositions == 0 && (!TradeInDirectionOfMA || (TradeInDirectionOfMA && MADIR() > 0))))) {
        CurrentSignal = Sell ? 3 : Sell2 ? 4 : Sell3 ? 7 : Sell4 ? 8 : Sell5 ? 9 : Sell6 ? 11 : Sell7 ? 13 : Sell8 ? 5 : 10;
        if(!TradeAllowed(IntegerToString(CurrentSignal)))return;
        if((!ReverseTrades && ordertypeclosed == ORDER_TYPE_SELL) || (ReverseTrades && ordertypeclosed == ORDER_TYPE_BUY))return;
        
        BuyFree = false;  
        /*if(!ReverseTrades)     
          CloseBuyOrders(CLOSE_REASON_OPPOSITE_TRADE);
        else
          CloseSellOrders(CLOSE_REASON_OPPOSITE_TRADE);*/
          
        LOT = (AutoLot || LotSize == 0) ? GetFlexibleLot(SL) : LotSize;
        if(MultiLot)LOT *= 3;
        
        if(MA(1) < MA(2))
        PlaceSellOrder(LOT, TP, SL, CurrentSignal, "");
    }    
    
    Comment(
        "\n==================" +
        "\n" + EaName + "\n" +
        "\n==================" +
        "\n" + "STOP LOSS = " + DoubleToString(SL, 0) +
        "\n" + "TAKE PROFIT = " + DoubleToString(TP, 0) +
        "\n==================" +
        "\n" + "BUY TRADES = " + DoubleToString(OpenBuyPositions, 0) +
        "\n" + "SELL TRADES = " + DoubleToString(OpenSellPositions, 0) +
        "\n" + "ACC. BALANCE = " + DoubleToString(myAccountBalance, 2) +
        "\n" + "ACC. EQUITY = " + DoubleToString(myAccountEquity, 2) +
        "\n==================" + 
        "\n" + "LAST 1 RSI PEAK = " + DoubleToString(RSIPeak1, 5) +
        "\n" + "LAST 2 RSI PEAK = " + DoubleToString(RSIPeak2, 5) +
        "\n" + "LAST 3 RSI PEAK = " + DoubleToString(RSIPeak3, 5) +
        "\n" + "LAST 1 RSI  VALLEY = " + DoubleToString(RSIValley1, 5) +
        "\n" + "LAST 2 RSI VALLEY = " + DoubleToString(RSIValley2, 5) +
        "\n" + "LAST 3 RSI VALLEY = " + DoubleToString(RSIValley3, 5) +
        "\n" + "LAST 1 MACD PEAK = " + DoubleToString(MACDPeak1, 5) +
        "\n" + "LAST 2 MACD PEAK = " + DoubleToString(MACDPeak2, 5) +
        "\n" + "LAST 3 MACD PEAK = " + DoubleToString(MACDPeak3, 5) +
        "\n" + "LAST 1 MACD VALLEY = " + DoubleToString(MACDValley1, 5) +
        "\n" + "LAST 2 MACD VALLEY = " + DoubleToString(MACDValley2, 5) + 
        "\n" + "LAST 3 MACD VALLEY = " + DoubleToString(MACDValley3, 5)
    );
    
     InitialCandleOpenTrade = iOpen(_Symbol,_Period,0);
}

void MakeComment(){    
    Comment(
        "\n==================" +
        "\n" + EaName +
        "\n==================" +
        "\n" + "STOP LOSS = " + DoubleToString(SL, 0) +
        "\n" + "TAKE PROFIT = " + DoubleToString(TP, 0) +
        "\n==================" +
        "\n" + "BUY TRADES = " + DoubleToString(OpenBuyPositions, 0) +
        "\n" + "SELL TRADES = " + DoubleToString(OpenSellPositions, 0) +
        "\n" + "ACC. BALANCE = " + DoubleToString(myAccountBalance, 2) +
        "\n" + "ACC. EQUITY = " + DoubleToString(myAccountEquity, 2) +
        "\n=================="
    );
}

int MADIR(){
   if(MA(1) > MA(2))
      return 1;
   else if(MA(1) < MA(2))
      return -1;
      
   return 0;
}

bool TradeAllowed(string signal){
   for(int i=0;i<ArraySize(allowedTrades);i++)
     {
         if(signal == allowedTrades[i])
            return true;
     }
     return false;
}

double Open(int i){
   return iOpen(_Symbol,_Period,i);
}
double High(int i){
   return iHigh(_Symbol,_Period,i);
}
double Low(int i){
   return iLow(_Symbol,_Period,i);
}
double Close(int i){
   return iClose(_Symbol,_Period,i);
}
bool IsGreen(int i){
   return (iClose(_Symbol,_Period,i) > iOpen(_Symbol,_Period,i));
}
bool IsRed(int i){
   return (iClose(_Symbol,_Period,i) < iOpen(_Symbol,_Period,i));
}
datetime Time(int i){
   return iTime(_Symbol,_Period,i);
}
double MA(int index){
   return iMA(_Symbol,_Period,MAPeriod,MAShift,MAMethod,MAAppliedPrice,index);
}
double MACD(int index){
   return iMACD(_Symbol,_Period,MACDFastEMA,MACDSlowEMA,MACDSMA,MACDAppliedPrice,MACDBuffer,index);
}
int MACDLEVEL(int index){
   if(index > 0)return 0;
   double Highest = iHigh(_Symbol,_Period,iHighest(_Symbol,_Period,MODE_HIGH,BarsInView,0));
   double Lowest = iLow(_Symbol,_Period,iLowest(_Symbol,_Period,MODE_LOW,BarsInView,0));
   double HeightSpan = Highest - Lowest;
   
   //Print(MACDFast(index), " ", MACDSlow(index));
   //Print("highest : " + Highest, " ", "Lowest : " + Lowest);
   
   //double macd = ((MACDFast(index) - MACDSlow(index)) / HeightSpan) * 100;
   //return 100 - (50 + macd);
 
   for(int c=0;c<BarsInView;c++)
     {
         double i = MACD(c);
         if(i > Highest) Highest = i;
         if(i < Lowest) Lowest = i;
     }
     
   double nowperc = (MACD(0) / HeightSpan) * 100;
   
   if(MACD(0) <= Lowest)
      return RSILowerLevel;
   else if(MACD(0) >= Highest)
      return RSIUpperLevel;
   else
      return 50;
}


double RSI(int index){
   return iRSI(_Symbol,_Period,RSIPeriod,RSIPrice,index);
}

double GetRSIValley(datetime offset, datetime &found){
   int count = iBars(_Symbol,_Period);
   for(int i=1;i<count-1;i++)
     {
         if(offset <= iTime(_Symbol, _Period, i))continue;
         double prev = RSI(i+1);
         double curr = RSI(i);
         double next = RSI(i-1);
         
         if(prev > curr && curr < next){
            found = iTime(_Symbol,_Period,i);
            return curr;
         }
      }
     return 0;
}

double GetRSIPeak(datetime offset, datetime &found){
   int count = iBars(_Symbol,_Period);
   for(int i=1;i<count-1;i++)
     {
         if(offset <= iTime(_Symbol, _Period, i))continue;
         double prev = RSI(i+1);
         double curr = RSI(i);
         double next = RSI(i-1);
         
         if(prev < curr && curr > next){
            found = iTime(_Symbol,_Period,i);
            return curr;
         }
     }
     return 0;
}

double GetMACDValley(datetime offset, datetime &found){
   int count = iBars(_Symbol,_Period);
   for(int i=1;i<count-1;i++)
     {
         if(offset <= iTime(_Symbol, _Period, i))continue;
         double prev = MACD(i+1);
         double curr = MACD(i);
         double next = MACD(i-1);
         if(curr > 0)continue;
         
         if(prev > curr && curr < next){
            found = iTime(_Symbol,_Period,i);
            return curr;
         }
      }
     return 0;
}

double GetMACDValleyAbove0(datetime offset, datetime &found){
   int count = iBars(_Symbol,_Period);
   for(int i=1;i<count-1;i++)
     {
         if(offset <= iTime(_Symbol, _Period, i))continue;
         double extend2 = MACD(i+3);
         double extend = MACD(i+2);
         double prev = MACD(i+1);
         double curr = MACD(i);
         double next = MACD(i-1);
         if(curr < 0)continue;
         
         if(extend2 > extend && extend > prev && prev > curr && curr < next){
            if(extend2 > 0 && extend > 0 && prev > 0 && next > 0){
               found = iTime(_Symbol,_Period,i);
               return curr;
            }
         }
      }
     return 0;
}

double GetMACDPeak(datetime offset, datetime &found){
   int count = iBars(_Symbol,_Period);
   for(int i=1;i<count-1;i++)
     {
         if(offset <= iTime(_Symbol, _Period, i))continue;
         double prev = MACD(i+1);
         double curr = MACD(i);
         double next = MACD(i-1);
         if(curr < 0)continue;
         
         if(prev < curr && curr > next){
            found = iTime(_Symbol,_Period,i);
            return curr;
         }
     }
     return 0;
}

double GetMACDPeakBelow0(datetime offset, datetime &found){
   int count = iBars(_Symbol,_Period);
   for(int i=1;i<count-2;i++)
     {
         if(offset <= iTime(_Symbol, _Period, i))continue;
         double extend2 = MACD(i+3);
         double extend = MACD(i+2);
         double prev = MACD(i+1);
         double curr = MACD(i);
         double next = MACD(i-1);
         if(curr > 0)continue;
         
         if(extend2 < extend && extend < prev && prev < curr && curr > next){
            if(extend2 < 0 && extend < 0 && prev < 0 && next < 0){
               found = iTime(_Symbol,_Period,i);
               return curr;
            }
         }
     }
     return 0;
}
/*
double BEA(int index){
   TesterHideIndicators(false);
   return iBearsPower(_Symbol, _Period,BearsPeriod,BearsPrice,index);
}
double BUL(int index){
   TesterHideIndicators(false);
   return iBullsPower(_Symbol, _Period,BullsPeriod,BullsPrice,index);
}
double BBUBLACK(int index){
   TesterHideIndicators(true);
   return iBands(_Symbol, _Period,BB1Period,BB1Deviation,BB1Shift,BB1Price,MODE_UPPER,index);
}
double BBMBLACK(int index){
   TesterHideIndicators(true);
   return (iBands(_Symbol, _Period,BB1Period,BB1Deviation,BB1Shift,BB1Price,MODE_UPPER,index) 
          + iBands(_Symbol, _Period,BB1Period,BB1Deviation,BB1Shift,BB1Price,MODE_LOWER,index)) / 2;
}
double BBLBLACK(int index){
   TesterHideIndicators(true);
   return iBands(_Symbol, _Period,BB1Period,BB1Deviation,BB1Shift,BB1Price,MODE_LOWER,index);
}
double BBUBLUE(int index){
  TesterHideIndicators(true);
   return iBands(_Symbol, _Period,BB2Period,BB2Deviation,BB2Shift,BB2Price,MODE_UPPER,index);
}
double BBMBLUE(int index){
   TesterHideIndicators(true);
   return (iBands(_Symbol, _Period,BB2Period,BB2Deviation,BB2Shift,BB2Price,MODE_UPPER,index) 
          + iBands(_Symbol, _Period,BB2Period,BB2Deviation,BB2Shift,BB2Price,MODE_LOWER,index)) / 2;
}
double BBLBLUE(int index){
   TesterHideIndicators(true);
   return iBands(_Symbol, _Period,BB2Period,BB2Deviation,BB2Shift,BB2Price,MODE_LOWER,index);
}
double BBUAQUA(int index){
   TesterHideIndicators(true);
   return iBands(_Symbol, _Period,BB3Period,BB3Deviation,BB3Shift,BB3Price,MODE_UPPER,index);
}
double BBMAQUA(int index){
   TesterHideIndicators(true);
   return (iBands(_Symbol, _Period,BB3Period,BB3Deviation,BB3Shift,BB3Price,MODE_UPPER,index) 
          + iBands(_Symbol, _Period,BB3Period,BB3Deviation,BB3Shift,BB3Price,MODE_LOWER,index)) / 2;
}
double BBLAQUA(int index){
   TesterHideIndicators(true);
   return iBands(_Symbol, _Period,BB3Period,BB3Deviation,BB3Shift,BB3Price,MODE_LOWER,index);
}

void SetCandleOpenParameters(){
    BBUBLACKopen = iBands(_Symbol, _Period,BB1Period,BB1Shift,BB1Deviation,BB1Price,0,0);
    BBLBLACKopen = iBands(_Symbol, _Period,BB1Period,BB1Shift,BB1Deviation,BB1Price,1,0);
    BBMBLACKopen = (BBUBLACKopen + BBLBLACKopen) / 2;
        
    BBUBLUEopen = iBands(_Symbol, _Period,BB2Period,BB2Shift,BB2Deviation,BB2Price,0,0);
    BBLBLUEopen = iBands(_Symbol, _Period,BB2Period,BB2Shift,BB2Deviation,BB2Price,1,0);
    BBMBLUEopen = (BBUBLUEopen + BBLBLUEopen) / 2;
        
    BBUAQUAopen = iBands(_Symbol, _Period,BB3Period,BB3Shift,BB3Deviation,BB3Price,0,0);
    BBLAQUAopen = iBands(_Symbol, _Period,BB3Period,BB3Shift,BB3Deviation,BB3Price,1,0);
    BBMAQUAopen = (BBUAQUAopen + BBLAQUAopen) / 2;
        
    EUYopen = iEnvelopes(_Symbol, _Period,EPeriod,EShift,EMethod,EPrice,EDeviation,0,0);
    ELRopen = iEnvelopes(_Symbol, _Period,EPeriod,EShift,EMethod,EPrice,EDeviation,1,0);
    
    MAGopen = iMA(_Symbol, _Period, MAPeriod, MAShift, MAMethod, MAPrice, 0);
}
*/

bool CheckTime(){
   if (DayOfWeek() == 5) {
        string dt = TimeToString(TimeCurrent());
        string DTstr = TimeToString(TimeCurrent(), TIME_DATE);
        string shut = DTstr + " " + FridayExitTime;
        StringToTime(dt);
        StringToTime(shut);
        
        if (dt >= shut){
           if (OpenPositions > 0) {
               CloseBuyOrders(0);
               CloseSellOrders(0);
               Print("Closing Open Trades at set time on friday");
           }
           return false;
        }
    }
    return true;
}

double MoneyValuePerPip(double money, double lot) {
    double TickValue = SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_VALUE);
    double TickSize = SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_SIZE);
    double MoneyValue = (money * TickSize) / (lot * TickValue);

    return MoneyValue / pips;
}

double PipValuePerLot(double pips_, double lot) {
    double TickValue = SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_VALUE);
    double TickSize = SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_SIZE);
    double PipValue = (((TickValue * pips_) / TickSize) * lot);
    double PointValue = PipValue / 10;
    return PipValue;
}

double LotValuePerPip(double pips_, double money) {
    double x = (SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_VALUE) * pips_) / SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_SIZE);
    double lot = money / x;
    return lot;
}

double GetTodayProfit(void) {
    double Res = 0;
    string todayTime = TimeToString(TimeCurrent(), TIME_DATE);

    for (int i = OrdersHistoryTotal() - 1; i >= 0; i--) {
        if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
            const ulong Ticket = OrderTicket();
            if (TimeToString(OrderOpenTime(), TIME_DATE) == todayTime) {

                if ((OrderMagicNumber() == MagicNumber) && (OrderSymbol() == Symbol()))
                    Res += OrderProfit();
            }
        }
    }
    
    for (int i = OrdersTotal() - 1; i >= 0; i--) {
        if (OrderSelect(i, SELECT_BY_POS)) {
            const ulong Ticket = OrderTicket();
            if (TimeToString(OrderOpenTime(), TIME_DATE) == todayTime) {

                if ((OrderMagicNumber() == MagicNumber) && (OrderSymbol() == Symbol()))
                    Res += OrderProfit();
            }
        }
    }

    return (Res);
}

double GetFlexibleLot(double sl) {
    double minlot = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MIN);
    double maxlot = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MAX);
    double tickVal = SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_VALUE);
    double _risk = Risk;

    double equ = AccountInfoDouble(ACCOUNT_EQUITY);
    double bal = AccountInfoDouble(ACCOUNT_BALANCE);
    _risk = _risk / 100;
    double numerator = equ * _risk;
    double denominator = sl * tickVal;

    if (numerator <= 0 || denominator <= 0) {
        // your choice of error handling
        Print("divide by error, setting lot to minlot");
        return (minlot);
    } else
    if (numerator / denominator <= 0) {
        // your choice of error handling
        return (minlot);
    } else {
        double result = (numerator / denominator);
        /*if (result < minlot) {
            Print(result , " is less than minLot ", minlot, " setting lot to minlot");
            result = minlot;
        } else if (result > maxlot) {
            Print(result , " is greater than maxLot ", maxlot, " setting lot to maxlot");
            result = maxlot;
        }*/

        //return result;
        //result = (result * 100) / 100;;
        return (EvenVolumeSize(result));
    }
}

double EvenVolumeSize(double lots) {
    Print("sending ", lots, " to EVS");
    double minLot = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MIN);
    double maxLot = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MAX);
    double OrderLotStep = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_STEP);
    double StepsInput = lots / OrderLotStep;

    double StepsOutput;
    if (_Digits == 1 && minLot == 0.1)
        StepsOutput = MathRound(lots / OrderLotStep) * OrderLotStep * 10;
    else
        StepsOutput = MathRound(StepsInput / 1) * 1;

    double EvenLotSize = OrderLotStep * StepsOutput;
    Print("receiving ", EvenLotSize, " from EVS");

    if (EvenLotSize < minLot) {
        EvenLotSize = minLot;
    }
    if (EvenLotSize > maxLot) {
        EvenLotSize = maxLot;
    }

    return EvenLotSize;
}

int CountDigits(double val, int maxPrecision = 8) {
    int digits = 0;
    while (NormalizeDouble(val, digits) != NormalizeDouble(val, maxPrecision))
        digits++;

    return digits;
}

bool InBetween(double high, double low, double value) {
    if (value > low && value < high)
        return true;
    return false;
}

void CheckOrdersProfit(){
   int TotalOrders = OrdersTotal();
    for (int i = TotalOrders - 1; i >= 0; i--) {
        if(OrderSelect(i,SELECT_BY_POS)){
           if (OrderSymbol() == _Symbol) {
               if (OrderMagicNumber() == MagicNumber) {
                    double profit = OrderProfit();
                    long ticket = (long)OrderTicket();
                    if(profit >= TakeProfitD && TakeProfitD != 0)
                        CloseOrderByTicket(ticket, "TakeProfit of " + DoubleToString(TakeProfitD) + " Reached.");
               }
           }
        }
    }
}

ENUM_ORDER_TYPE CheckOrdersToClose(){
   bool MACD_or_RSI_A_90 = (MACDLEVEL(1) == RSIUpperLevel || RSI(1) > RSIUpperLevel) && MA(0) < MA(1);
   bool MACD_or_RSI_B_10 = (MACDLEVEL(1) == RSILowerLevel || RSI(1) < RSILowerLevel) && MA(0) > MA(1);
   double StopLossD_ = StopLossD > 0 ? StopLossD * -1 : StopLossD < 0 ? StopLossD : 0;

   ENUM_ORDER_TYPE ordertypeclosed = -1;
                  
   int TotalOrders = OrdersTotal();
    for (int i = TotalOrders - 1; i >= 0; i--) {
        if (OrderSelect(i,SELECT_BY_POS) && OrderSymbol() == _Symbol) {
            if (OrderMagicNumber() == MagicNumber) {
               long ticket = (long)OrderTicket();
               string comm = OrderComment();
               double profit = (double)OrderProfit();
               ENUM_ORDER_TYPE type = (ENUM_ORDER_TYPE)OrderType();
            
               string arr[]; StringSplit(comm, '*', arr);
               if(ArraySize(arr) < 2)continue;
               double tpreal = StringToDouble(arr[0]);
               double slreal = StringToDouble(arr[1]);
               //Print("--2 " + comm);
                if(exit_feature==0)
                 if(((!ReverseTrades && type == ORDER_TYPE_BUY) || (ReverseTrades && type == ORDER_TYPE_SELL)) && MACD_or_RSI_A_90){
                     CloseOrderByTicket(ticket, "1#" + comm);
                     ordertypeclosed = type;
                 }
                if(exit_feature==0)
                 if(((!ReverseTrades && type == ORDER_TYPE_SELL) || (ReverseTrades && type == ORDER_TYPE_BUY)) && MACD_or_RSI_B_10){
                     CloseOrderByTicket(ticket, "2#" + comm);
                     ordertypeclosed = type;
                 }
                 if(TakeProfitD > 0 && profit >= TakeProfitD){
                     CloseOrderByTicket(ticket, "3#" + comm);
                     ordertypeclosed = type;
                 }
                 if(StopLossD_ < 0 && profit <= StopLossD_){
                     CloseOrderByTicket(ticket, "4#" + comm);
                     ordertypeclosed = type;
                 }
                 if(type == ORDER_TYPE_BUY && ((tpreal > 0 && Bid >= tpreal) || (slreal > 0 && Bid <= slreal))){
                     CloseOrderByTicket(ticket, "5#" + comm);
                     ordertypeclosed = type;
                 }
                 if(type == ORDER_TYPE_SELL && ((tpreal > 0 && Ask <= tpreal) || (slreal > 0 && Ask >= slreal))){
                     CloseOrderByTicket(ticket, "6#" + comm);
                     ordertypeclosed = type;
                 }
            }
        }
    }
    return ordertypeclosed;
}

int CountOpenPositions() {
    OpenBuyPositions = 0; OpenSellPositions = 0;
    int TotalOrders = OrdersTotal();
    for (int i = TotalOrders - 1; i >= 0; i--) {
        if (OrderSelect(i,SELECT_BY_POS) && OrderSymbol() == _Symbol) {
            if (OrderMagicNumber() == MagicNumber) {
                ulong ticket = OrderTicket();
                ulong PositionDirection = OrderType();
                if (PositionDirection == ORDER_TYPE_BUY) {
                    OpenBuyPositions++;
                }
                if (PositionDirection == ORDER_TYPE_SELL) {
                    OpenSellPositions++;
                }
            }
        }
    }

    if (OpenBuyPositions == 0) {
        ONBUY = false;
        buyLock = false;
    }else
        ONBUY = true;
        
    if (OpenSellPositions == 0) {
        ONSELL = false;
        sellLock = false;
    }else
        ONSELL = true;
        
    if (!ONBUY && !ONSELL){
        broken_even = false;
        CandlesOnTradeElapsed = 0;
        MA0TradeCount = 0;
        ObjectsDeleteAll(0,linePrefix);
    }

    return (OpenBuyPositions + OpenSellPositions);
}

void PlaceBuyOrder(double Lot, double tp, double sl, int signal, string comment) {
    if(comment != "-" && comment != "*"){
       if(ReverseTrades || (TradeInDirectionOfMA && MADIR() == -1)){
         PlaceSellOrder(Lot,tp,sl,signal,"*");
         return;
       }
    }
    
    double tp_ = Ask + tp * pips;
    double tp_decoy = Ask + (tp + 4) * pips;
    if (tp == 0) {
        tp_ = 0;
        tp_decoy = 0;
    }
    
    double sl_ = Ask - sl * pips;
    double sl_decoy = Ask - (sl + 5) * pips;
    if (sl == 0) {
        sl_ = 0;
        sl_decoy = 0;
    }
    
    int ticket;
    ticket = OrderSend(
        _Symbol,
        OP_BUY,
        Lot,
        NormalizeDouble(Ask, _Digits),
        3, //slippage
        NormalizeDouble(sl_decoy, _Digits),
        NormalizeDouble(tp_decoy, _Digits),
        (DoubleToString(tp_)+"*"+DoubleToString(sl_)),
        MagicNumber,
        0,
        clrGreen
    );
    
    if (ticket > 0) {        
        if(signal == 6)MABuyTradeTicket = ticket;
        if(signal == 0)MA0TradeCount++;
        PriceOpenTrade = Ask;
        if(UseRuleNumAboveTrades)DrawLetter(signal,1);
        DrawLine(tp_, 1);
        DrawLine(sl_, -1);
        Print("Sending Buy Order : Signal Buy => ", IntegerToString(signal), " ", comment);
    }
}

void PlaceSellOrder(double Lot, double tp, double sl, int signal, string comment) {
    if(comment != "-" && comment != "*"){
       if(ReverseTrades || (TradeInDirectionOfMA && MADIR() == 1)){
         PlaceBuyOrder(Lot,tp,sl,signal,"*");
         return;
       }
    }
    
    double tp_ = Bid - tp * pips;
    double tp_decoy = Bid - (tp + 5) * pips;
    if (tp == 0) {
        tp_ = 0;
        tp_decoy = 0;
    }
    
    double sl_ = Bid + sl * pips;
    double sl_decoy = Bid + (sl + 5) * pips;
    if (sl == 0) {
        sl_ = 0;
        sl_decoy = 0;
    }
    
    int ticket;
    ticket = OrderSend(
        _Symbol,
        OP_SELL,
        Lot,
        NormalizeDouble(Bid, _Digits),
        3, //slippage
        NormalizeDouble(sl_decoy, _Digits),
        NormalizeDouble(tp_decoy, _Digits),
        (DoubleToString(tp_)+"*"+DoubleToString(sl_)),
        MagicNumber,
        0,
        clrRed
    );
    
    if (ticket) {
        if(signal == 1)MASellTradeTicket = ticket;
        if(signal == 0)MA0TradeCount++;
        PriceOpenTrade = Bid;
        if(UseRuleNumAboveTrades)DrawLetter(signal,-1);
        DrawLine(tp_, 1);
        DrawLine(sl_, -1);
        Print("Sending Sell Order : Signal Sell => ", IntegerToString(signal), " ", comment);
    }
}

void DrawLetter(int LineText, int direction) {
   int dist = 600;
   if(_Period < 60) dist /= 4;
   
    string ArrowName = TimeToString(TimeCurrent());
    if (ObjectCreate(0, ArrowName, OBJ_TEXT, 0, iTime(_Symbol,_Period,0) , iHigh(_Symbol,_Period,0) + dist * _Point)) {
        ObjectSetString(0, ArrowName, OBJPROP_TEXT, IntegerToString(LineText));
        ObjectSetInteger(0, ArrowName, OBJPROP_COLOR, direction == 1 ? BuyColor : SellColor);
        ObjectSetDouble(0, ArrowName, OBJPROP_PRICE, iHigh(_Symbol,_Period,0) + dist * _Point);
        ObjectSetInteger(0, ArrowName, OBJPROP_TIME, iTime(_Symbol,_Period,0));
        ObjectSetInteger(0, ArrowName, OBJPROP_FONTSIZE, 10);
    }
}

void DrawLine(double level, int type) {
   color Color;
   if(type == 1){
      Color = clrSkyBlue;
   }else{
      Color = clrTomato;
   }
   
    string LineName = linePrefix + DoubleToString(level);
    if (ObjectCreate(0, LineName, OBJ_HLINE, 0, iTime(_Symbol,_Period,0), level)) {
        //ObjectSetString(0, LineName, OBJPROP_TEXT, IntegerToString(LineText));
        ObjectSetInteger(0, LineName, OBJPROP_COLOR, Color);
        ObjectSetDouble(0, LineName, OBJPROP_PRICE, level);
        //ObjectSetInteger(0, LineName, OBJPROP_TIME, iTime(_Symbol,_Period,0));
        //ObjectSetInteger(0, LineName, OBJPROP_FONTSIZE, 10);
    }else
      Print(GetLastError());
}

bool CloseOrderByTicket(long ticket, string reason) {
    bool ClosedAPosition = false;
    for (int i = OrdersTotal() - 1; i >= 0; i--) {
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderTicket() == ticket) {
               double price = OrderType() == ORDER_TYPE_BUY ? Bid : Ask;
               color clr = OrderType() == ORDER_TYPE_BUY ? clrRed : clrGreen;
               if (OrderClose(OrderTicket(), OrderLots(), price, 3, clr)) {
                   ClosedAPosition = true;
                   Print("Order(s) closed successfully. Reason : " + reason);
               } else
                   Print("UTCO : ", GetLastError());
           }
        }
    }
    OpenPositions = CountOpenPositions();
    return ClosedAPosition;
}

bool CloseBuyOrders(int r) {
     
    bool ClosedAPosition = false;
    for (int i = OrdersTotal() - 1; i >= 0; i--) {
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol() == _Symbol) {
                if (OrderMagicNumber() == MagicNumber) {
                    int ticket = OrderTicket();
                    if (OrderType() == OP_BUY) {
                        if (OrderClose(OrderTicket(), OrderLots(), Bid, 3, Red)) {
                            ClosedAPosition = true;
                            //Print("Buy Order(s) closed successfully");;
                        } else
                            Print("Unable to close buy orders : ", GetLastError());
                    }
                }
            }
        }
    }
    OpenPositions = CountOpenPositions();
    return ClosedAPosition;
}

bool CloseSellOrders(int r) {
    int OrderTotal = OrdersTotal();
    bool ClosedAPosition = false;
    for (int i = OrderTotal - 1; i >= 0; i--) {
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol() == _Symbol) {
                if (OrderMagicNumber() == MagicNumber) {
                    int ticket = OrderTicket();
                    if (OrderType() == OP_SELL) {
                        if (OrderClose(OrderTicket(), OrderLots(), Ask, 3, Green))
                            ClosedAPosition = true;
                    }
                }
            }
        }
    }
    OpenPositions = CountOpenPositions();
    return ClosedAPosition;
}

void OnDeinit(const int reason) {
    ObjectsDeleteAll(0,Prefix);
    Print(__FUNCTION__, "_Uninitalization reason code = ", reason);
    //--- The second way to get the uninitialization reason code
    Print(__FUNCTION__, "_UninitReason = ", getUninitReasonText(_UninitReason));
}

string getUninitReasonText(int reasonCode) {
    string text = "";
    switch (reasonCode) {
    case REASON_ACCOUNT:
        text = "Account was changed";
        break;
    case REASON_CHARTCHANGE:
        text = "Symbol or timeframe was changed";
        break;
    case REASON_CHARTCLOSE:
        text = "Chart was closed";
        break;
    case REASON_PARAMETERS:
        text = "Input-parameter was changed";
        break;
    case REASON_RECOMPILE:
        text = "Program " + __FILE__ + " was recompiled";
        break;
    case REASON_REMOVE:
        text = "Program " + __FILE__ + " was removed from chart";
        break;
    case REASON_TEMPLATE:
        text = "New template was applied to chart";
        break;
    default:
        text = "Another reason";
    }
    return text;
}

bool isNewCandle()
  {

   bool result;
   if(total_bars == Bars)
      result = false;
   else
      result = true;
   total_bars = Bars;
   return result;
  } 